/*******************************************************************************
 * file:        config.js
 * author:      KMV.Subramanyam
 * description: Cylock Server Configuration
*******************************************************************************/


 var CyLock_Auth_Server = { 
	url             : 'https://demoauth.cybernexa.com/api/v2/srv/',
	id_sp           : '110002195004',
	content_type    : 'application/x-www-form-urlencoded',
	Authorization   : '3cddbf77b8204efb9310',
	trans_str		: 'SSL VPN – Login',
	sp_code         : 'RAD_011',
	user_ip			: '0.0.0.0'
};

var Server_Config = {

	//Allow POTP BOTH
	//True - Trigger POTP through SMS & EMAIL
	//False - Trigger Either SMS or EMAIL based on preferred value set
	potp_both                : 'True',

	//AD check is required (MS-AD / OpenLDAP )
	//True - Enables AD Check
	//False - Disable Ad Check
	need_ad                  : 'True',

	//Use AD or OpenLDAP
	//True - Check in MS-AD Server
	//False - Check in OpenLDAP Server
	use_ad_ldap              : 'True',

	//Allow - supports both default auth, based on CyLock portal settings and dynamic authentication through password,<choice>
	//Deny  - Support only default auth, based on CyLock portal settings
	dual_auth				 : 'Allow',
	
	//failover True - will allow you to bypass Cylock 2FA
	//failover False - will not allow you to bypass Cylock 2FA		
	failover				 : 'False',

    //True - Check for Localuser first and then proceed to AD if required. 
	//False - Only AD users need to check  	
	check_local_user         : 'True', 
	
	//Allow - Allows Device Registration based on API and displays QR Code / Registration Token will be displayed
	//Deny  - Don't allow registtation in client side (Assumes USer's are properly registrated via CyLock Portal)
	device_registration      : 'Allow',	
	
	radius_secret			 : 'd27feb710b0093aad8',
	radius_server_port 		 : '1812',
	radius_accounting_port 	 : '1813'

};

require('strict-mode')(function () {
	module.exports = {  CyLock_Auth_Server, Server_Config }
});


